/* $Id: cllarc.h,v 1.1 1997/04/23 19:27:35 lfm Exp $ */
/*
** --------------------------------------------------------------------
** cllarc.h - Prototypes for module of circle arc primitive 
**             collection.
**
** Created:    09-Jun-94    Joao Luiz E. Campos
**
** Modified:   13-Oct-96    Luiz F. Martha
**     Version to use with CD graphics package.
**
** Modified:   28-Jan-97    LFM
**     Added parameters "shift" and "control" to snap callback function.
**
** Modified:   03-Mar-97    LFM
**     Added keyboard collection function CllKbdArcCreate.
**
** Modified:   17-Apr-97    LFM
**     Added return status parameter for end action function.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _CLLARC_H
#define _CLLARC_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _cllarc {    /* Collected arc:     */
  CllPnt     center;            /* arc center        */
  CllPnt     p0;                /* first arc point   */
  CllPnt     p1;                /* second arc point  */
  double     radius;            /* arc radius        */
  double     ang0;              /* angle at first pt */
  double     ang1;              /* angle at end pt   */
 } CllArc;

/* Public functions:
*/
void CllArcCreate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *arc, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol,
                              int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdArcCreate( Ihandle *iup_cv, 
                      void (*put)( Ihandle *iup_cv, void *arc, double tol ),
                      void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
