/* $Id: cllcircl.h,v 1.1 1997/04/23 19:28:52 lfm Exp $ */
/*
** --------------------------------------------------------------------
** cllcircl.h - Prototypes for module of circle primitive 
**              collection.
**
** Created:    12-Apr-94    Luiz F. Martha
**
** Modified:   13-Oct-96    LFM
**     Version to use with CD graphics package.
**
** Modified:   28-Jan-97    LFM
**     Added parameters "shift" and "control" to snap callback function.
**
** Modified:   03-Mar-97    LFM
**     Added keyboard collection function CllKbdCircleCreate.
**
** Modified:   17-Apr-97    LFM
**     Added return status parameter for end action function.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _CLLCIRCL_H
#define _CLLCIRCL_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _cllcircle {    /* Collected circle:     */
  CllPnt     center;            /* circle center        */
  CllPnt     p0;                /* circle point         */
  double     radius;            /* circle radius        */
 } CllCircle;

/* Public functions:
*/
void CllCircleCreate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *circle, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol,
                              int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdCircleCreate( Ihandle *iup_cv, 
                         void (*put)( Ihandle *iup_cv, void *circle, double tol ),
                         void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
