/* $Id: clldimln.h,v 1.1 2000/03/02 16:21:06 lfm Exp $ */
/*
** --------------------------------------------------------------------
** clldimln.h - Prototypes for module of dimension line primitive 
**              collection.
**
** Created:    28-Feb-2000  Luiz F. Martha
**     Stolen form cllarc.h and modified.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _CLLDIMLN_H
#define _CLLDIMLN_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _clldimln {    /* Collected dimension line: */
  CllPnt     p0;                /* first target point   */
  CllPnt     p1;                /* second target point  */
  CllPnt     p0off;             /* first offset point   */
  CllPnt     p1off;             /* second offset point  */
  CllPnt     ref;               /* reference offset pnt.*/
 } CllDimLn;

/* Public functions:
*/
void CllDimLnCreate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *dimln, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol,
                              int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdDimLnCreate( Ihandle *iup_cv, 
                      void (*put)( Ihandle *iup_cv, void *dimln, double tol ),
                      void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
