/*
** --------------------------------------------------------------------
** cllelipse.h - Prototypes for module of elipse primitive 
**               collection.
**
** Created:    18-Mar-2005    Marcos C. de Arruda
**
*/

#ifndef _CLLELIPSE_H
#define _CLLELIPSE_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _cllelipse {    /* Collected elipse:    */
 CllPnt center;     /* centro da elipse */
 double a;          /* primeiro semi-eixo da elipse */
 double b;          /* segundo semi-eixo da elipse */
 double ang;        /* ngulo que a elipse faz com o eixo horizontal (x) */
 } CllElipse;

/* Public functions:
*/
void CllElipseCreate( Ihandle *iup_cv, void *cd_cv,
                      void (*end_action)( Ihandle *iup_cv, int status ),
                      void (*put)( Ihandle *iup_cv, void *elipse, double tol ),
                      void (*prompt)( Ihandle *iup_cv, char *msg ),
                      void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                                    double tol, int shift, int control ),
                      void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdElipseCreate( Ihandle *iup_cv, 
                         void (*put)( Ihandle *iup_cv, void *elipse, 
                                      double tol ),
                         void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
