/*
** --------------------------------------------------------------------
** cllelparc.h - Prototypes for module of elypse arc primitive 
**               collection.
**
** Created:    07-Mar-2005    Marcos C. de Arruda
**
*/

#ifndef _CLLELPARC_H
#define _CLLELPARC_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _cllelparc {    /* Collected elypse arc:    */
 CllPnt center;     /* centro da elipse */
 CllPnt p0;         /* ponto inicial do arco */
 CllPnt p1;         /* ponto final do arco */
 double a;          /* primeiro semi-eixo da elipse */
 double b;          /* segundo semi-eixo da elipse */
 double ang;        /* ngulo que a elipse faz com o eixo horizontal (x) */
 double ang0;       /* ngulo inicial do arco */
 double ang1;       /* ngulo final do arco */
 } CllElpArc;

/* Public functions:
*/
void CllElpArcCreate( Ihandle *iup_cv, void *cd_cv,
                   void (*end_action)( Ihandle *iup_cv, int status ),
                   void (*put)( Ihandle *iup_cv, void *elparc, double tol ),
                   void (*prompt)( Ihandle *iup_cv, char *msg ),
                   void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                                 double tol, int shift, int control ),
                   void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdElpArcCreate( Ihandle *iup_cv, 
                         void (*put)( Ihandle *iup_cv, void *elparc, 
                                      double tol ),
                         void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
