/* $Id: cllpnt.h,v 1.1 1997/04/23 19:30:29 lfm Exp $ */
/*
** --------------------------------------------------------------------
** cllpnt.h - Prototypes for module of point primitive 
**            collection.
**
** Created:    12-Apr-94    Joao Luiz E. Campos.
**
** Modified:   30-May-95    LFM
**     Version to use with CD graphics package.
**     This file was renamed from cllpoint.h to cllpnt.h.
**     Got rid of GraPnt, replacing it by CllPnt.  CllPoint was
**     redefined as CllPnt: structure containing two fields: x, y.
**     Replaced double by float.
**     Changed prototype of snap and echo functions so that point
**     structure is replaced by x and y coordinates.
**
** Modified:   07-Mar-96    LFM
**     When CD changed, creating cdCreateCanvas, which returns
**     a CD handle for the canvas.
**     Changed CllPntCreate adding a parameter which is the CD
**     canvas handle.
**
** Modified:   28-Jan-97    LFM
**     Added parameters "shift" and "control" to snap callback function.
**
** Modified:   03-Mar-97    LFM
**     Added keyboard collection function CllKbdPntCreate.
**
** Modified:   17-Apr-97    LFM
**     Added return status parameter for end action function.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _CLLPNT_H
#define _CLLPNT_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public functions:
*/
void CllPntCreate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *pt, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol,
                              int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdPntCreate( Ihandle *iup_cv, 
                      void (*put)( Ihandle *iup_cv, void *pt, double tol ),
                      void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
