/* $Id: $ */
/*
** --------------------------------------------------------------------
** cllspline.h - Prototypes for module of spline primitive 
**               collection.
**
** Created:    17-Dec-2002    Marcos C. de Arruda
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _CLLSPLINE_H
#define _CLLSPLINE_H

#include "cll.h"   /* CllPnt */

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _cllspline {    /* Collected spline:            */
         int     dg;         /* Spline degree */ 
         int     np;         /* Number of control points */
         int     nu;         /* Number of knots in knot vector */
         int     numpts;     /* Number of interpolation points */
         double  *knot;      /* Knot vector (parametrization) */
         CllPnt  *keypts;    /* Interpolation points */
         CllPnt  *ctrlpts;   /* Control points */
         CllPnt  itan;       /* Curve tangent (first derivate) on 
                                first point */
         CllPnt  ftan;       /* Curve tangent (first derivate) on 
                                last point */
 } CllSpline;

/* Public functions:
*/
void CllSplineCreate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *pline, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol,
                              int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y ) );
int  CllKbdSplineCreate( Ihandle *iup_cv, 
                        void (*put)( Ihandle *iup_cv, void *pline, double tol ),
                        void (*prompt)( Ihandle *iup_cv, char *msg ) );


#ifdef __cplusplus
}
#endif

#endif
