/* $Id: drag.h,v 1.1 1997/04/23 19:30:57 lfm Exp $ */
/*
** ---------------------------------------------------------------
**
** drag.h - Header file of generic drag functions for use with 
**         Gra package with binding to GKS and Iup graphics interface.
**
** ---------------------------------------------------------------
**
** TeCGraf - Grupo de Tecnologia em Computacao Grafica, PUC-Rio
**
** Created:    22-Jul-95    Joaquim Bento Cavalcante Neto
**
** Modified:   15-Feb-96    LFM
**     Changed from Gra version to CD verstion.
**     Replaced float by double.
**
** Modified:   07-Mar-96    LFM
**     When CD changed, creating cdCreateCanvas, which returns
**     a CD handle for the canvas.
**     Changed DragOpen adding a second parameter which is the CD
**     canvas handle.
**
** Modified:   23-Apr-97    LFM
**     Added parameters "shift" and "control" to snap callback function.
**     Created macro definitions for end_action return status.
**     Added return status parameter for end_action function.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
** ---------------------------------------------------------------
*/

#ifndef _DRAG_H
#define _DRAG_H

#include "iup.h"

#ifdef __cplusplus
extern "C" {
#endif

#define   DRAG_NORMAL      1
#define   DRAG_QUIT        0
#define   DRAG_INTERUPTED -1

int  DragOpen   ( Ihandle *iup_cv, void *cd_cv );
void DragClose  ( Ihandle *iup_cv );
void DragRegFunc( Ihandle *iup_cv, 
                  void (*selpk)  ( Ihandle *iup_cv, double x, double y,
                                         double tol, int shift, int control ),
                  void (*put)    ( Ihandle *iup_cv, double x0, double y0,
                                                 double x1, double y1,
                                                 double tol ),
                  void (*prompt) ( Ihandle *iup_cv, char *msg ),
                  void (*snap)   ( Ihandle *iup_cv, double *x, double *y, 
                                         double tol, int shift, int control ),
                  void (*echo)   ( Ihandle *iup_cv, double x0, double y0,
                                                 double x1, double y1 ) );
void DragSetup  ( Ihandle *iup_cv, void (*end_action)( Ihandle *iup_cv, int status ), 
                                int tolbox );
#ifdef __cplusplus
}
#endif

#endif
