/* $Id: sel.h,v 1.2 1997/09/08 10:50:09 lfm Exp $ */
/*
** ---------------------------------------------------------------
** sel.h - Header file of generic selection functions for use with 
**         CD graphics package and Iup graphics interface.
**
** ---------------------------------------------------------------
**
** Created:    09-Feb-94    Luiz F. Martha
**
** Modified:   28-Mar-94    LFM
**     Added "reinit" and "tolbox" parameters to SelSetup.
**
** Modified:   11-Apr-94    LFM
**     Eliminated "reinit" parameter in SelSetup and added
**     "end_action" parameter.
**
** Modified:   29-May-95    LFM
**     Changed from Gra version to CD verstion.
**     Replaced float by double.
**
** Modified:   07-Mar-96    LFM
**     When CD changed, creating cdCreateCanvas, which returns
**     a CD handle for the canvas.
**     Changed SelOpen adding a second parameter which is the CD
**     canvas handle.
**
** Modified:   17-Apr-97    LFM
**     Created macro definitions for end action return status.
**     Added return status parameter for end action function.
**
** Modified:   07-Sep-97    LFM
**     Added snap and echo callback functions parameters to SelRegFunc.
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _SEL_H
#define _SEL_H

#include "iup.h"

#ifdef __cplusplus
extern "C" {
#endif

#define   SEL_NORMAL      1
#define   SEL_QUIT        0
#define   SEL_INTERUPTED -1

int  SelOpen   ( Ihandle *iup_cv, void *cd_cv );
void SelClose  ( Ihandle *iup_cv );
void SelRegFunc( Ihandle *iup_cv, 
                 void (*selpk)( Ihandle *iup_cv, double x, double y, double tol, 
                                              int shift, int control ),
                 void (*selfc)( Ihandle *iup_cv, double xmn, double xmx, 
                                              double ymn, double ymx, 
                                              int shift, int control ),
                 void (*snap)( Ihandle *iup_cv, double *x, double *y, double tol, 
                               int shift, int control ),
                 void (*echo)( Ihandle *iup_cv, double x, double y ) );
void SelSetup  ( Ihandle *iup_cv, void (*end_action)( Ihandle *iup_cv, int status ),
                 int tolbox );

#ifdef __cplusplus
}
#endif

#endif
