/*
** ---------------------------------------------------------------
** T2d.h: Definitions and prototypes for package to manage 2D
**        matrix transformations.
**
*/

#ifndef _T2D_H
#define _T2D_H 

/* Matrix type
 */
typedef double Matrix2d[2][3];

/* Prototypes of functions
 */
#ifdef __cplusplus
extern "C" {
#endif

void T2dTransform( double *x, double *y );
void T2dGetTransform( Matrix2d mtx );
void T2dSetTransform( Matrix2d mtx );
void T2dIdentity( void );
void T2dInverse( void );
void T2dTranslate( double dx, double dy );
void T2dScale( double sx, double sy );
void T2dScaleAbout( double cx, double cy, double sx, double sy );
void T2dRotate( double angle );
void T2dRotateAbout( double cx, double cy, double angle );
void T2dShear( double shx, double shy );
void T2dShearAbout( double cx, double cy, double shx, double shy );
void T2dMirrorX( void );
void T2dMirrorY( void );
void T2dMirrorVec( double vx0, double vy );
void T2dMirrorVecAbout( double x0, double y0, double x1, double y1 );

#ifdef __cplusplus
}
#endif

#endif
