/* $Id: trf.h,v 1.1 1997/04/23 19:33:20 lfm Exp $ */
/*
** --------------------------------------------------------------------
** trf.h - Definitions and prototypes for module of collection and
**         generation of matrix transformations.
**
** Created:    17-Apr-97    Luiz Fernando Martha
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _TRF_H
#define _TRF_H

#include "iup.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/

#define   TRF_NORMAL      1
#define   TRF_QUIT        0
#define   TRF_INTERUPTED -1

typedef enum _trftype {      /* Transformation types:                  */
  TRF_MOVE,                      /* move (translation) transformation  */
  TRF_MIRROR,                    /* mirror transformation              */
  TRF_ROTATE,                    /* rotation transformation            */
  TRF_SCALE,                     /* scale transformation               */
  NumTrfTypes
 } TrfType;

/* Public functions:
*/
void TrfCollect( TrfType type, 
                 Ihandle *iup_cv, void *cd_cv,
                 void (*end_action)( Ihandle *iup_cv, int status ),
                 void (*put)( Ihandle *iup_cv, void *trf, double tol ),
                 void (*prompt)( Ihandle *iup_cv, char *msg ),
                 void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                               double tol, int shift, int control ),
                 void (*echo)( Ihandle *iup_cv, double x, double y, 
                               int status, double mat[2][3] ) );

int  TrfKbdCollect( TrfType type, 
                    Ihandle *iup_cv, 
                    void (*put)( Ihandle *iup_cv, void *trf, double tol ),
                    void (*prompt)( Ihandle *iup_cv, char *msg ) );

void TrfShiftSnap( double x0, double y0, double *x1, double *y1 );

#ifdef __cplusplus
}
#endif

#include "trfmove.h"
#include "trfmirr.h"
#include "trfrotat.h"
#include "trfscale.h"

#endif
