/* $Id: trfmirr.h,v 1.1 1997/04/23 19:33:53 lfm Exp $ */
/*
** --------------------------------------------------------------------
** trfmirr.h - Functions for collection and generation of matrix 
**             transformations for mirroring objects.
**
** Created:    17-Apr-97    Luiz Fernando Martha
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _TRFMIRR_H
#define _TRFMIRR_H

#include "trf.h"

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _trfmr 
{
 double  p0x, p0y, p1x, p1y;     /* mirror line points           */
 double  mat[2][3];              /* mirror transformation matrix */
} TrfMr;

/* Public functions:
*/
void TrfMirror( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *m, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                              double tol, int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y, 
                              int status, double mat[2][3] ) );

int  TrfKbdMirror( Ihandle *iup_cv, 
                   void (*put)( Ihandle *iup_cv, void *m, double tol ),
                   void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
