/* $Id: trfrotat.h,v 1.1 1997/04/23 19:34:58 lfm Exp $ */
/*
** --------------------------------------------------------------------
** trfrotat.h - Functions for collection and generation of matrix 
**              transformations for rotating objects.
**
** Created:    17-Apr-97    Luiz Fernando Martha
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _TRFROTAT_H
#define _TRFROTAT_H

#include "trf.h" 

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _trfrt 
{
 double  cx, cy;           /* center of rotation             */
 double  angle;            /* angle of rotation              */
 double  mat[2][3];        /* rotation transformation matrix */
} TrfRt;

/* Public functions:
*/
void TrfRotate( Ihandle *iup_cv, void *cd_cv,
                void (*end_action)( Ihandle *iup_cv, int status ),
                void (*put)( Ihandle *iup_cv, void *r, double tol ),
                void (*prompt)( Ihandle *iup_cv, char *msg ),
                void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                              double tol, int shift, int control ),
                void (*echo)( Ihandle *iup_cv, double x, double y, 
                              int status, double mat[2][3] ) );

int  TrfKbdRotate( Ihandle *iup_cv, 
                   void (*put)( Ihandle *iup_cv, void *r, double tol ),
                   void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
