/* $Id: trfscale.h,v 1.1 1997/04/23 19:35:46 lfm Exp $ */
/*
** --------------------------------------------------------------------
** trfscale.h - Functions for collection and generation of matrix 
**              transformations for scaling objects.
**
** Created:    17-Apr-97    Luiz Fernando Martha
**
** Modified:   21-Apr-2004    William Lira
**     Replaced "void *" by "Ihandle *" in declarations of IUP handles.
**
*/

#ifndef _TRFSCALE_H
#define _TRFSCALE_H

#include "trf.h" 

#ifdef __cplusplus
extern "C" {
#endif

/* Public definitions:
*/
typedef struct _trfsc 
{
 double  cx, cy;              /* center of scaling             */
 double  sx, sy;              /* scaling factors               */
 double  mat[2][3];           /* scaling transformation matrix */
} TrfSc;

/* Public functions:
*/
void TrfScale( Ihandle *iup_cv, void *cd_cv,
               void (*end_action)( Ihandle *iup_cv, int status ),
               void (*put)( Ihandle *iup_cv, void *s, double tol ),
               void (*prompt)( Ihandle *iup_cv, char *msg ),
               void (*snap)( Ihandle *iup_cv, double *x, double *y, 
                             double tol, int shift, int control ),
               void (*echo)( Ihandle *iup_cv, double x, double y, 
                             int status, double mat[2][3] ) );

int  TrfKbdScale( Ihandle *iup_cv, 
                  void (*put)( Ihandle *iup_cv, void *s, double tol ),
                  void (*prompt)( Ihandle *iup_cv, char *msg ) );

#ifdef __cplusplus
}
#endif

#endif
